/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.exchange.items.calendar.model;

import java.util.Date;

/**
 * @version $Id: Calendar.java,v 1.1 2006/08/08 07:47:36 gibi Exp $
 */

public class Calendar
        extends com.funambol.foundation.pdi.event.Event {

    //------------------------------------------------------------- Private data

    private String id = null;

    private String href = null;

    private Date lastUpdate = null;
    private char modificationStatus = ' ';

    //------------------------------------------------------------- Constructors

    /**
     * Creates a Calendar
     */
    public Calendar() {

    }

    /**
     * Creates a Calendar
     *
     * @param id client item id
     */
    public Calendar(String id) {

        this.id = id;

    }

    /**
     * Creates a Calendar
     *
     * @param id client item id
     * @param t  client item timestamp
     */
    public Calendar(String id, Date t) {

        this.id = id;
        this.lastUpdate = t;

    }

    /**
     * Creates a Calendar
     *
     * @param id
     * @param status
     */
    public Calendar(String id, char status) {

        this.id = id;
        this.modificationStatus = status;

    }

    /**
     * Creates a Calendar
     *
     * @param id
     * @param href
     * @param status
     * @param lastUpdate
     */
    public Calendar(String id,
                    String href,
                    char status,
                    Date lastUpdate) {

        this.id = id;
        this.href = href;
        this.modificationStatus = status;
        this.lastUpdate = lastUpdate;

    }

    public Calendar(com.funambol.foundation.pdi.event.Event event) {
        if (event == null) {
            return;
        }
        copy(event);
    }

    //----------------------------------------------------------- Public methods

    public String getId() {
        return id;
    }

    public Date getLastUpdate() {
        return lastUpdate;
    }


    public char getModificationStatus() {
        return modificationStatus;
    }

    public String getHref() {
        return href;
    }

    public void setId(String id) {
        this.id = id;
    }

    public void setLastUpdate(Date lastUpdate) {
        this.lastUpdate = lastUpdate;
    }

    public void setModificationStatus(char status) {
        this.modificationStatus = status;
    }

    public void setHref(String href) {
        this.href = href;
    }

    public void copy(com.funambol.foundation.pdi.event.Event event) {
        if (event == null) {
            return;
        }

        this.setReminder(event.getReminder());
        this.setCategories(event.getCategories());
        this.setClassEvent(event.getClassEvent());
        this.setDescription(event.getDescription());
        this.setLatitude(event.getLatitude());
        this.setLongitude(event.getLongitude());
        this.setLocation(event.getLocation());
        this.setPriority(event.getPriority());
        this.setStatus(event.getStatus());
        this.setSummary(event.getSummary());
        this.setDtEnd(event.getDtEnd());
        this.setDtStart(event.getDtStart());
        this.setDuration(event.getDuration());
        this.setTransp(event.getTransp());
        this.setOrganizer(event.getOrganizer());
        this.setUrl(event.getUrl());
        this.setUid(event.getUid());
        this.setContact(event.getContact());
        this.setCreated(event.getCreated());
        this.setDtStamp(event.getDtStamp());
        this.setLastModified(event.getLastModified());
        this.setSequence(event.getSequence());
        this.setXTag(event.getXTags());
        this.setAllDay(Boolean.valueOf(event.isAllDay()));
        this.setMeetingStatus(event.getMeetingStatus());
        this.setMileage(event.getMileage());
        this.setReplyTime(event.getReplyTime());
        this.setRecurrencePattern(event.getRecurrencePattern());
        this.setBusyStatus(event.getBusyStatus());
    }
}
