/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.exchange.items.common.model;

import java.util.Date;

/**
 *
 * @version $Id: Item.java,v 1.1 2006/08/08 07:48:29 gibi Exp $
 **/
public class Item {

    //------------------------------------------------------------- Private data

    private String    id            = null  ;
    private String    href          = null  ;

    private long      crc           = 0     ;

    private Date      creationDate  = null  ;
    private Date      lastModified  = null  ;

    //------------------------------------------------------------- Constructors

    /**
     * Creates a Item
     *
     */
    public Item () {

    }

    /**
     * Creates a Item
     *
     * @param id
     */
    public Item (String id) {

        this.id            = id    ;
        this.href          = null  ;
        this.creationDate  = null  ;
        this.lastModified  = null  ;

    }

    /**
     * Creates a Item
     *
     * @param id
     * @param lastModified
     *
     */
    public Item (String id,
                 Date   lastModified) {

        this.id            = id            ;
        this.href          = null          ;
        this.creationDate  = null          ;
        this.lastModified  = lastModified  ;

    }

    /**
     * Creates a Item
     *
     * @param id
     * @param href
     * @param lastUpdate
     *
     */
    public Item (String id          ,
                 String href        ,
                 String lastUpdate)  {

        this.id            = id    ;
        this.href          = null  ;
        this.lastModified  = null  ;

    }

    /**
     * Creates a Item
     *
     * @param id
     * @param creationDate
     * @param lastModified
     *
     */
    public Item (String    id           ,
                 String    href         ,
                 Date      creationDate ,
                 Date      lastModified) {

        this.id            = id            ;
        this.href          = href          ;
        this.creationDate  = creationDate  ;
        this.lastModified  = lastModified  ;

    }

    /**
     * Creates a Item
     *
     * @param id
     * @param lastModified
     * @param crc
     *
     */
    public Item (String    id           ,
                 Date      lastModified ,
                 long      crc          ) {

        this.id            = id            ;
        this.lastModified  = lastModified  ;
        this.crc           = crc           ;

    }

    /**
      * Creates a Item
      *
      * @param id
      * @param href
      * @param lastModified
      * @param crc
      *
      */
     public Item (String    id           ,
                  String    href         ,
                  Date      lastModified ,
                  long      crc          ) {

         this.id            = id            ;
         this.href          = href          ;
         this.lastModified  = lastModified  ;
         this.crc           = crc           ;

    }

    /**
     * Creates a Item
     *
     * @param id
     * @param creationDate
     * @param lastModified
     *
     */
    public Item (String    id           ,
                 String    href         ,
                 Date      creationDate ,
                 Date      lastModified ,
                 long      crc          ) {

        this.id            = id            ;
        this.href          = href          ;
        this.creationDate  = creationDate  ;
        this.lastModified  = lastModified  ;
        this.crc           = crc           ;

    }

    //----------------------------------------------------------- Public methods

    public String getId()                           {
        return this.id;
    }

    public String getHref()                         {
        return this.href;
    }

    public Date getCreationDate()                   {
        return this.creationDate;
    }

    public Date getLastModified()                   {
        return this.lastModified;
    }

    public long getCRC()                            {
        return this.crc;
    }

    public void setId(String id)                    {
        this.id = id;
    }

    public void setHref(String href)                {
        this.href = href;
    }

    public void setCreationDate(Date creationDate)  {
        this.creationDate = creationDate;
    }

    public void setLastModified(Date lastModified)  {
        this.lastModified = lastModified;
    }

    public void setCRC(long crc)  {
        this.crc = crc;
    }

}